<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">    
      <el-form-item label="金额" prop="price">
        <el-input
            v-model="queryParams.price"
            placeholder="请输入金额"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>    
      <el-form-item label="优惠后金额" prop="discountPrice">
        <el-input
            v-model="queryParams.discountPrice"
            placeholder="请输入优惠后金额"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>    
      <el-form-item label="配置类型" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择配置类型" clearable size="small">
            <el-option
                v-for="dict in typeOptions"
                :key="dict.key"
                :label="dict.value"
                :value="dict.key"
            />
        </el-select>
      </el-form-item>      
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['jx_horizon/jxHorizonConfig/add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['jx_horizon/jxHorizonConfig/edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['jx_horizon/jxHorizonConfig/delete']"
        >删除</el-button>
      </el-col>
    </el-row>
    <el-table v-loading="loading" :data="jxHorizonConfigList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />      
      <el-table-column label="系统id" align="center" prop="id" />      
      <el-table-column label="金额" align="center" prop="price" />      
      <el-table-column label="优惠后金额" align="center" prop="discountPrice" />      
      <el-table-column label="配置类型" align="center" prop="type" :formatter="typeFormat" />      
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['jx_horizon/jxHorizonConfig/edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['jx_horizon/jxHorizonConfig/delete']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 添加或修改金额配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">      
      <el-form-item label="金额" prop="price">
           <el-input v-model="form.price" placeholder="请输入金额" />
      </el-form-item>      
      <el-form-item label="优惠后金额" prop="discountPrice">
           <el-input v-model="form.discountPrice" placeholder="请输入优惠后金额" />
      </el-form-item>      
      <el-form-item label="配置类型" prop="type">
          <el-select v-model="form.type" placeholder="请选择配置类型">
              <el-option
                  v-for="dict in typeOptions"
                  :key="dict.key"
                  :label="dict.value"                  
                      :value="dict.key"                  
              ></el-option>
          </el-select>
      </el-form-item>       
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import {
    listJxHorizonConfig,
    getJxHorizonConfig,
    delJxHorizonConfig,
    addJxHorizonConfig,
    updateJxHorizonConfig,    
} from "@/api/jx_horizon/jxHorizonConfig";
export default {
  components:{    
  },
  name: "JxHorizonConfig",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 金额配置表格数据
      jxHorizonConfigList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,      
      // typeOptions字典数据
      typeOptions: [],      
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        price: undefined,
        discountPrice: undefined,
        type: undefined,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: { 
        price : [
          { required: true, message: "金额不能为空", trigger: "blur" }
        ],
        discountPrice : [
          { required: true, message: "优惠后金额不能为空", trigger: "blur" }
        ],
        type : [
          { required: true, message: "配置类型不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {    
    this.getDicts("sys_config").then(response => {
      this.typeOptions = response.data.values||[];
    });
    this.getList();
  },
  methods: {    
    /** 查询金额配置列表 */
    getList() {
      this.loading = true;
      listJxHorizonConfig(this.queryParams).then(response => {
        let list = response.data.list || [];        
        this.jxHorizonConfigList = list;        
        this.total = response.data.total;
        this.loading = false;
      });
    },    
    // 配置类型字典翻译
    typeFormat(row, column) {
      return this.selectDictLabel(this.typeOptions, row.type);
    },    
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {        
        createdAt: undefined,        
        updatedAt: undefined,        
        id: undefined,        
        price: undefined,        
        discountPrice: undefined,        
        type: undefined,        
      };      
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!=1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加金额配置";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getJxHorizonConfig(id).then(response => {
        let data = response.data;        
        data.type = ''+data.type        
        this.form = data;
        this.open = true;
        this.title = "修改金额配置";
      });
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != undefined) {
            updateJxHorizonConfig(this.form).then(response => {
              if (response.code === 0) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          } else {
            addJxHorizonConfig(this.form).then(response => {
              if (response.code === 0) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除金额配置编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delJxHorizonConfig(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    }
  }
};
</script>
<style>
</style>